BinaryChoiceView subclass: #ConfirmView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ConfirmView class
	instanceVariableNames: ''!


!ConfirmView class methodsFor: 'private'!

buildSwitchesFor: aConfirm width: anInteger 
	| switchView okSwitchView |
	switchView _ View new model: aConfirm.
	switchView controller: BinaryChoiceController new.
	okSwitchView _ SwitchView new model: aConfirm.
	okSwitchView borderWidth: 0.
	okSwitchView selector: #active.
	okSwitchView controller selector: #selectTrue.
	okSwitchView controller cursor: Cursor thumbsUp.
	okSwitchView label: 'Ok' asParagraph.
	okSwitchView window: (0 @ 0 extent: anInteger @ okSwitchView window height).
	switchView addSubView: okSwitchView.
	switchView
		borderWidthLeft: 0
		right: 0
		top: 2
		bottom: 0.
	^switchView! !

BinaryChoice subclass: #ConfirmDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ConfirmDialog class
	instanceVariableNames: ''!


!ConfirmDialog class methodsFor: 'instance creation'!

message: messageString displayAt: aPoint centered: centered ifTrue: trueAlternative ifFalse: falseAlternative 
	"Predefinovana metoda predka. Misto vyberu ze dvou alternativ se ceka na 
	stisk tlacitka Ok, pote se provede trueAlternative."

	| newChoice |
	newChoice _ self new initialize.
	newChoice trueAction: trueAlternative.
	newChoice falseAction: falseAlternative.
	ConfirmView
		openOn: newChoice
		message: messageString
		displayAt: aPoint
		centered: centered! !

FormMenuView subclass: #IkonMenuView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!IkonMenuView methodsFor: 'updating'!

update
	^self! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

IkonMenuView class
	instanceVariableNames: ''!


!IkonMenuView class methodsFor: 'instance creation'!

iconMenu
	"vytvori menu icon slozene ze dvou sloupcu"

	| iconNames buttonKeys actions relpos ext button connector aSwitchView menuView i ic |
	iconNames _ #(#rectangle #arrow #cross #hand #expand #compact #fileIn #fileOut #book #run ).
	buttonKeys _ #($r $c $d $m $x $b $l $s $i $r ).
	menuView _ self new.
	menuView insideColor: Form gray.
	actions _ Array new: 10.
	actions at: 1 put: [menuView model akce: #addNode].
	actions at: 2 put: [menuView model akce: #addConnection].
	actions at: 3 put: [menuView model akce: #remove].
	actions at: 4 put: [menuView model akce: #moveNode].
	actions at: 5 put: [menuView model akce: #succLevel].
	actions at: 6
		put: 
			[menuView model predLevel.
			menuView model akce: #noAction].
	actions at: 7
		put: 
			[menuView model fileIn.
			menuView model akce: #noAction].
	actions at: 8
		put: 
			[menuView model fileOut.
			menuView model akce: #noAction].
	actions at: 9 put: [menuView model akce: #inspectIt].
	actions at: 10
		put: 
			[menuView model compile ifTrue: [menuView model topDocument run].
			menuView model akce: #noAction].
	relpos _ 0 @ 0.
	ext _ relpos + (0.5 @ 0.2).
	i _ 1.
	connector _ Object new.
	iconNames do: 
		[:n | 
		ic _ Ikona perform: n.
		button _ OneOnSwitchRep newOff.
		button onAction: (actions at: i).
		button connection: connector.
		aSwitchView _ SwitchView new model: button.
		aSwitchView key: (buttonKeys at: i).
		aSwitchView label: ic.
		aSwitchView insideColor: Form white.
		aSwitchView borderWidth: 1.
		aSwitchView controller selector: #turnOn.
		menuView
			addSubView: aSwitchView
			in: (relpos extent: ext)
			borderWidth: 1.
		relpos x = 0
			ifTrue: [relpos _ relpos + (0.5 @ 0)]
			ifFalse: 
				[relpos x: 0.
				relpos y: relpos y + 0.2].
		i _ i + 1].
	^menuView! !

View subclass: #MoverView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!MoverView methodsFor: 'displaying'!

displayView
	
	(self moverBox) displayAt: self insetDisplayBox origin! !

!MoverView methodsFor: 'private'!

moverBox
	"vraci instanci tridy GraphNode predstavujici obdelnik urcujici vyrez, ktery 
	budeme posunovat"

	| mvbox |
	mvbox _ Form extent: (self model extent scaleBy: 0.1 @ 0.1) rounded.
	mvbox white.
	mvbox borderWidth: 1.
	mvbox offset: (self displayBox extent -  mvbox extent // 2) + (self model origin // 10).
	^mvbox! !

!MoverView methodsFor: 'updating'!

update: aParameter 
	"pokud se zmenily rozmery okna modelu nebe jeho realtivni pocatek okno se 
	prekresli"

	self display! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MoverView class
	instanceVariableNames: ''!


!MoverView class methodsFor: 'instance creation'!

openOn: document 
	| moverView topView |
	moverView _ (MoverView new)
	      model: document; 
		controller: MoverController new;
	      borderWidth: 2; insideColor: Form white.
	topView _ (StandardSystemView new)
		 label: 'Mover - [' ,(document title),']'; 
		 minimumSize: 100 @ 100; 
            addSubView: moverView.
	topView controller open! !

Inspector subclass: #DocumentInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!DocumentInspector methodsFor: 'field list'!

fieldList
	"vraci seznam inspectovanych polozek"

	^Array
		with: 'self'
		with: 'nazev'
		with: 'komentar'!

fieldValue
	"vraci hodnotu inspectovane polozeky"

	field = 'self' ifTrue: [^object].
	field = 'nazev' ifTrue: [^object title].
	field = 'komentar' ifTrue: [^object komentar]! !

!DocumentInspector methodsFor: 'accept'!

acceptText: aText from: aController 
	| val |
	object class == CompiledMethod ifTrue: [^false].
	field == nil ifTrue: [^false].
	val _ self
				evaluateText: aText string
				from: aController
				ifFail: [^false].
	field = 'nazev'
		ifTrue: 
			[object title: val.
			self changed].
	field = 'komentar' ifTrue: [object komentar: val].
	self changed: #text.
	^true! !

View subclass: #DialogInspectorView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!DialogInspectorView methodsFor: 'testing'!

isCollapsed

^false! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DialogInspectorView class
	instanceVariableNames: ''!


!DialogInspectorView class methodsFor: 'instance creation'!

open: anInspector 
	| newInspector savedArea frame |
	frame _ 0 @ 0 corner: 300 @ 200.
	Cursor origin showWhile: [Display
			outline: [frame _ (frame moveTo: Sensor cursorPoint) rounded]
			while: [Sensor anyButtonPressed not]
			width: 2
			halftone: Form gray].
	Sensor cursorPoint: (frame corner max: Sensor cursorPoint).
	Cursor corner showWhile: [Display
			outline: [frame corner: (Sensor cursorPoint max: frame origin + (100 @ 100))]
			while: [Sensor anyButtonPressed]
			width: 2
			halftone: Form gray].
	newInspector _ self new.
	newInspector window: (0 @ 0 extent: frame extent).
	newInspector controller: DialogBoxController new initialize.
	InspectorView
		view: anInspector
		in: (0 @ 0 corner: 1 @ 1)
		of: newInspector.
	newInspector align: newInspector viewport topLeft with: frame origin.
	savedArea _ Form fromDisplay: newInspector displayBox.
	newInspector display.
	newInspector controller centerCursorInView.
	newInspector controller startUp.
	newInspector release.
	savedArea displayOn: Display at: newInspector viewport topLeft!

open: anInspector at: aDisplayPoint centered: centered 
	| newInspector savedArea |
	newInspector _ self new.
	newInspector window: (0 @ 0 extent: 300 @ 200).
	newInspector controller: DialogBoxController new initialize.
	InspectorView
		view: anInspector
		in: (0 @ 0 corner: 1 @ 1)
		of: newInspector.
	newInspector align: (centered
			ifTrue: [newInspector viewport center]
			ifFalse: [newInspector viewport topLeft])
		with: aDisplayPoint.
	savedArea _ Form fromDisplay: newInspector displayBox.
	newInspector display.
	newInspector controller centerCursorInView.
	newInspector controller startUp.
	newInspector release.
	savedArea displayOn: Display at: newInspector viewport topLeft! !

Inspector subclass: #NodeInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!NodeInspector methodsFor: 'accept'!

acceptText: aText from: aController 
	"Text has been changed. Store or compile the text, depending on 
	the current mode of the receiver."

	| val |
	object class == CompiledMethod ifTrue: [^false].
	field == nil ifTrue: [^false].
	val _ self
				evaluateText: aText string
				from: aController
				ifFail: [^false].
	field = 'nazev'
		ifTrue: [object label: val]
		ifFalse: [(object atributeAt: field)
				atributValue: val].
	self changed: #text.
	^true! !

!NodeInspector methodsFor: 'field list'!

fieldList
	"vraci seznam inspectovanych polozek"

	^(Array with: 'self' with: 'nazev' with: 'komentar'), object atributes keys asSortedCollection!

fieldValue
	"vraci hodnotu inspectovane polozeky"

	field = 'self' ifTrue: [^object].
	field = 'nazev' ifTrue: [^object label].
	field = 'komentar' ifTrue: [^object class comment].
	^(object atributeAt: field) atributValue! !

!NodeInspector methodsFor: 'text'!

textMenu
	"Answer an ActionMenu of operations on the text of the selected 
	variable's value that is to be displayed when the operate menu 
	button is pressed."
	"Inspector flushMenus"

	TextMenu == nil ifTrue: 
		[TextMenu _ 
			ActionMenu
				labels: 'Opakovat akci\Zrusit akci\Kopie text\Vystrizeni text\Vlozeni text\Spustit oznaceny blok\Spustit blok + vystup\Inspektor objektu\Ulozenit zmen\Zrusit zmeny' withCRs
				lines: #(2 5 8 )
				selectors: #(#again #undo #copySelection #cut #paste #doIt #printIt #inspectIt #accept #cancel )].
	^TextMenu! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NodeInspector class
	instanceVariableNames: ''!


!NodeInspector class methodsFor: 'class initialization'!

initialize
	TextMenu _ 
			ActionMenu
				labels: 'Opakovat akci\Zrusit akci\Kopie textu\Vystrizeni textu\Vlozeni textu\Spustit oznaceny blok\Spustit blok + vystup\Inspektor objektu\Ulozit zmeny\Zrusit zmeny' withCRs
				lines: #(2 5 8 )
				selectors: #(#again #undo #copySelection #cut #paste #doIt #printIt #inspectIt #accept #cancel )! !

NodeInspector initialize!


NodeInspector subclass: #MainNodeInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!MainNodeInspector methodsFor: 'field list'!

fieldList
	"vraci seznam inspectovanych polozek"

	^super fieldList, object registers keys asSortedCollection, (Array with: 'simulace')!

fieldValue
	"vraci hodnotu inspectovane polozeky"

	| val |
	field = 'simulace' ifTrue: [^object simulation].
	val _ object registers at: field ifAbsent: [nil].
	val == nil ifTrue: [^super fieldValue].
	^val! !

NodeInspector subclass: #GeneratorInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!GeneratorInspector methodsFor: 'accept'!

acceptText: aText from: aController 
	"Text has been changed. Store or compile the text, depending on 
	the current mode of the receiver."

	| val lastVal |
	field == nil ifTrue: [^false].
	field = 'tw-rozlozeni'
		ifTrue: 
			[val _ self
						evaluateText: aText string
						from: aController
						ifFail: [^false].
			lastVal _ (object atributeAt: field) atributValue.
			lastVal = 'E' ifTrue: [object removeAtribute: 'tw-A'].
			lastVal = 'U'
				ifTrue: 
					[object removeAtribute: 'tw-a'.
					object removeAtribute: 'tw-b'].
			lastVal = 'K' ifTrue: [object removeAtribute: 'tw'].
			val = 'E' ifTrue: [object addAtribute: (Atribut defaultValue: 100 lock: false)
					at: 'tw-A'].
			val = 'U'
				ifTrue: 
					[object addAtribute: (Atribut defaultValue: 0 lock: false)
						at: 'tw-a'.
					object addAtribute: (Atribut defaultValue: 100 lock: false)
						at: 'tw-b'].
			val = 'K' ifTrue: [object addAtribute: (Atribut defaultValue: 100 lock: false)
					at: 'tw'].
			(object atributeAt: field)
				atributValue: val.
			self changed: #field].
	^super acceptText: aText from: aController! !

MouseMenuController subclass: #ModelarController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!ModelarController methodsFor: 'private'!

move: aDisplayObject 
	"bude posunovat zobrazitelny objekt v okne podle polohy kurzoru dokud bude 
	stisknute tlacitka."

	| clip windowOrigin pos offs pos1 |
	clip _ self view insetDisplayBox.
	windowOrigin _ clip origin.
	Cursor currentCursor: Cursor hand.
	pos _ Sensor cursorPoint.
	pos1 _ pos.
	offs _ windowOrigin - pos1 - self model origin.
	aDisplayObject
		displayOn: Display
		at: pos + offs
		clippingBox: clip
		rule: Form reverse
		mask: Form gray.
	[Sensor anyButtonPressed]
		whileTrue: [pos = Sensor cursorPoint
				ifFalse: 
					[aDisplayObject
						displayOn: Display
						at: pos + offs
						clippingBox: clip
						rule: Form reverse
						mask: Form gray.
					(clip containsPoint: pos)
						ifTrue: 
							[pos _ Sensor cursorPoint.
							aDisplayObject
								displayOn: Display
								at: pos + offs
								clippingBox: clip
								rule: Form reverse
								mask: Form gray]
						ifFalse: 
							[Cursor currentCursor: Cursor normal.
							^nil]]].
	aDisplayObject
		displayOn: Display
		at: pos + offs
		clippingBox: clip
		rule: Form reverse
		mask: Form gray.
	Cursor currentCursor: Cursor normal.
	^pos - pos1 + aDisplayObject offset! !

!ModelarController methodsFor: 'menu messages'!

addConnection
	"spoji dva uzly orientovanou carou"

	| con p1 p2 line aform from to windowOrigin clip |
	clip _ self view insetDisplayBox.
	windowOrigin _ clip origin.
	con _ Connection new.
	line _ nil.
	aform _ (Form new) extent: 3 @ 3; black.
	Cursor currentCursor: Cursor crossHair.
	p1 _ Sensor waitClickButton.
	from _ self model findNodeAt: p1 - windowOrigin + self model origin.
	from ~~ nil
		ifTrue: 
			[con begin: from.
			con add: p1.
			
			["p2 _ Sensor waitClickButton."
			[Sensor noButtonPressed]
				whileTrue: 
					[p2 _ Sensor cursorPoint.
					p2 = p1
						ifFalse: 
							[line == nil
								ifTrue: 
									[line _ Line new.
									line form: aform.
									line beginPoint: p1.
									line endPoint: p2.
									line
										displayOn: Display
										at: 0 @ 0
										clippingBox: clip
										rule: Form reverse
										mask: Form gray]
								ifFalse: 
									[line
										displayOn: Display
										at: 0 @ 0
										clippingBox: clip
										rule: Form reverse
										mask: Form gray.
									line endPoint: p2.
									line
										displayOn: Display
										at: 0 @ 0
										clippingBox: clip
										rule: Form reverse
										mask: Form gray].
							p1 _ p2]].
			(clip containsPoint: p2)
				ifFalse: 
					[self view display.
					Cursor currentCursor: Cursor normal.
					^self].
			to _ self model findNodeAt: p2 - windowOrigin + self model origin.
			to == nil]
				whileTrue: 
					[con add: p2.
					line _ nil.
					p1 _ p2.
					Sensor waitNoButton ].
			con end: to.
			con add: p2.
			con _ con translateBy: self model origin - windowOrigin.
			self model addConnection: con.
			self view display].
	Cursor currentCursor: Cursor normal!

addNode
	"prida do dokumentu dalsi uzel"

	| aNode pos clip windowOrigin offs |
	clip _ self view insetDisplayBox.
	windowOrigin _ clip origin.
	aNode _ self model nodeClass new: 80 @ 50.
	pos _ Sensor cursorPoint.
	aNode offset: self model origin + pos - windowOrigin.
	offs _ self move: aNode.
	offs ~~ nil
		ifTrue: 
			[aNode offset: offs.
			(self model isNodeAt: aNode relativeRectangle)
				ifTrue: [self view flash]
				ifFalse: 
					[aNode
						displayOn: Display
						at: windowOrigin - self model origin
						clippingBox: clip.
					model addNode: aNode]]!

cancelSim
	^self model cancelSim!

compile
	"Spusti kompilaci simulacniho modelu. Vraci true nebo false podle vysledku kompilace"

	^self model compile!

initSim
	^self model initSim!

inspection
	"spusti inspector modelu"

	self view inspect!

inspectIt
	"Podle polohy kurzoru vyvola inspekci bud uzlu, nebo spoje nebo dokumentu"

	| windowOrigin pos num node con |
	pos _ Sensor waitNoButton.
	windowOrigin _ self view insetDisplayBox origin.
	num _ self model findNodeAt: pos - windowOrigin + self model origin.
	num ~~ nil
		ifTrue: [num >= 0
				ifTrue: 
					[node _ self model nodeWithNumber: num.
					Sensor waitNoButton.
					InspectorView open: (node defaultInspectorClass inspect: node).
					self model changed]]
		ifFalse: 
			[con _ self model connectionNearestTo: pos - windowOrigin + self model origin.
			con ~~ nil
				ifTrue: 
					[InspectorView open: (con defaultInspectorClass inspect: con).
					self model changed]
				ifFalse: [InspectorView open: (self model defaultInspectorClass inspect: self model)]]!

moveNode
	"posune jeden uzel"

	| aNode pos clip ninx offs windowOrigin con lb linFit inx pos1 form |
	clip _ self view insetDisplayBox.
	windowOrigin _ clip origin.
	pos _ Sensor cursorPoint.
	ninx _ self model findNodeAt: pos - windowOrigin + self model origin.
	ninx ~~ nil
		ifTrue: 
			["Na techto souradnicich se nachazi uzel, ktery se bude posouvat"
			aNode _ self model nodeWithNumber: ninx.
			aNode
				displayOn: Display
				at: windowOrigin - self model origin
				clippingBox: clip
				rule: Form erase
				mask: Form black.
			offs _ self move: aNode.
			offs ~~ nil ifTrue: [(self model isNodeAt: (aNode relativeRectangle moveTo: offs)
					but: aNode number)
					ifTrue: [self view flash]
					ifFalse: 
						[aNode offset: offs.
						self model moveConnectionsOn: ninx]].
			self view display]
		ifFalse: 
			["zkusime posouvat label"
			con _ self model findConnectionWithLabelAt: pos - windowOrigin + self model origin.
			con ~~ nil
				ifTrue: 
					[lb _ MyParagraph string: con label.
					lb offset: con firstPoint + con labelPosition.
					lb
						displayOn: Display
						at: windowOrigin - self model origin
						clippingBox: clip
						rule: Form erase
						mask: Form black.
					offs _ self move: lb.
					offs ~~ nil ifTrue: [con labelPosition: offs - con firstPoint].
					self view display]
				ifFalse: 
					["zkusime posouvat cast lomene cary spoje"
					con _ self model connectionNearestTo: pos - windowOrigin + self model origin.
					con == nil
						ifFalse: 
							[inx _ con pointNearestTo: pos - windowOrigin + self model origin.
							inx == nil
								ifFalse: 
									["Mame bod, ktery se bude posouvat"
									form _ Form extent: 3 @ 3.
									form black.
									linFit _ LinearFit new.
									linFit form: con form.
									linFit add: (con at: inx - 1); add: (con at: inx); add: (con at: inx + 1).
									linFit
										displayOn: Display
										at: windowOrigin - self model origin
										clippingBox: clip
										rule: Form erase
										mask: Form black.
									linFit form: form.
									linFit
										displayOn: Display
										at: windowOrigin - self model origin
										clippingBox: clip
										rule: Form reverse
										mask: Form black.
									Sensor cursorPoint: (linFit at: 2)
											- self model origin + windowOrigin.
									Cursor currentCursor: Cursor hand.
									pos1 _ pos.
									[Sensor anyButtonPressed]
										whileTrue: 
											[pos _ Sensor cursorPoint.
											pos = pos1
												ifFalse: 
													[linFit
														displayOn: Display
														at: windowOrigin - self model origin
														clippingBox: clip
														rule: Form reverse
														mask: Form black.
													linFit at: 2 put: pos - windowOrigin + self model origin.
													linFit
														displayOn: Display
														at: windowOrigin - self model origin
														clippingBox: clip
														rule: Form reverse
														mask: Form black.
													pos1 _ pos]].
									Cursor currentCursor: Cursor normal.
									con at: inx put: (linFit at: 2).
									self model moveConnectionsOn: con begin.
									self view display]]]]!

redButtonActivity
	"rozhoduje co se bude provadet pri stisku leveho tlacitka mysi"

	model akce = #noAction ifFalse: [self menuMessageReceiver perform: (model akce) ]!

remove
	"zrusi uzel na kterem je kurzor nebo hranu, ktrera lezi nejblize kursoru"

	| pos done |
	pos _ Sensor waitNoButton.
	pos _ pos - self view insetDisplayBox origin + self model origin.
	done _ self model removeNodeAt: pos.
	done ifFalse: [done _ self model removeConnectionNearestTo: pos].
	done ifTrue: [self view display]!

renumber
	
self model renumber!

run
	"Zkompiluje simulacni model a spusti simulaci"

	self model compile ifTrue: [self model run].!

simulate
	"Zkompiluje simulacni model a spusti simulaci"

	self model compile ifTrue: [self model topDocument run].
	self view topView controller == (ScheduledControllers activeController) ifFalse: [Processor terminateActive]!

simulateSpool
	"Zkompiluje simulacni model a spusti simulaci"

	| copie |
	copie _ self model topDocument copy.
	copie compile ifTrue: [copie runOnBackground].
	self view topView controller == (ScheduledControllers activeController) ifFalse: [Processor terminateActive]!

succLevel
	"prejde na nasledujici uroven v hieraricke strukture. Provede expanzi zvoleneho 
	uzlu."

	| p1 windowOrigin expandNodeNumber expandNode nmodel cn port scale relativpos |
	windowOrigin _ self view insetDisplayBox origin.
	p1 _ Sensor waitClickButton.
	expandNodeNumber _ self model findNodeAt: p1 - windowOrigin + self model origin.
	expandNodeNumber ~~ nil
		ifTrue: 
			[expandNode _ self model nodeWithNumber: expandNodeNumber.
			(expandNode class isKindOf: StructuredNode class)
				ifTrue: 
					[expandNode subStructure == nil
						ifTrue: 
							[nmodel _ self model class new.
							nmodel title: expandNode label.
							nmodel extent: self model extent.
							nmodel hierarchiLevel: self model hierarchiLevel + 1.
							nmodel number: expandNodeNumber.
							nmodel nodeCategory: self model nodeCategory.
							scale _ self model extent / expandNode extent.
							nmodel superDocument: self model.
							cn _ self model connectionsOnNode: expandNodeNumber.
							cn do: 
								[:con | 
								port _ Port new: 30 @ 30.
								con begin = expandNodeNumber
									ifTrue: 
										[port out.
										con end >= 0
											ifTrue: [port externNumber: con end]
											ifFalse: [port externNumber: (self model nodeWithNumber: con end) externNumber].
										relativpos _ (con firstPoint - expandNode offset * scale) rounded.
										nmodel addPort: port onPosition: relativpos]
									ifFalse: 
										[port in.
										con begin >= 0
											ifTrue: [port externNumber: con begin]
											ifFalse: [port externNumber: (self model nodeWithNumber: con begin) externNumber].
										relativpos _ (con last - expandNode offset * scale) rounded.
										nmodel addPort: port onPosition: relativpos]].
							expandNode subStructure: nmodel]
						ifFalse: [nmodel _ expandNode subStructure].
					self model dependents do: [:obj | obj model: nmodel].
					nmodel changed: #title]]! !

!ModelarController methodsFor: 'control defaults'!

isControlActive
	^super isControlActive & sensor blueButtonPressed not! !

!ModelarController methodsFor: 'initialize-release'!

initialize
	super initialize.
	
	self yellowButtonMenu: (PopUpMenu
			labels: 
'Precislovat uzly\Kompilace\Spustit simulaci\Simulovat na pozadi\Zastavit vsechny simulace\Inicializace systemu' withCRs lines: #(1 4))
		yellowButtonMessages: #(renumber compile simulate simulateSpool cancelSim initSim )! !

Model subclass: #ModelarDocument
	instanceVariableNames: 'nodes connections origin title extent akce hierarchiLevel superDocument nodeCategory nodeClass dirty number lastNodeNumber komentar '
	classVariableNames: 'ActiveDocument '
	poolDictionaries: ''
	category: 'Modelar-interface'!


!ModelarDocument methodsFor: 'testing'!

isNodeAt: aRect 
	"vraci boolovskou hodnotu, zda obdelnik aRect koliduje s nejakym uzlem"

	nodes detect: [:node | node intersects: aRect]
		ifNone: [^false].
	^true!

isNodeAt: aRect but: aNodeNumber 
	"Vraci pravdivostni hodnotu, zda obdelnik aRect koliduje s nejakym uzlem s 
	vyjimkou uzlu s cislem aNodeNumber"

	nodes detect: [:node | (node intersects: aRect)
			& (node number ~= aNodeNumber)]
		ifNone: [^false].
	^true! !

!ModelarDocument methodsFor: 'action controll'!

akce
	"vraci aktualne nastavenou akci"

	^akce!

akce: aSymbol 
	"nastavi aktualni akci podle parametru aSymbol"

	| categoryList labels menu choice |
	akce _ aSymbol.
	aSymbol = #addNode
		ifTrue: 
			[categoryList _ SystemOrganization listAtCategoryNamed: nodeCategory.
			labels _ Array with: categoryList with: #(#StructuredNode ).
			menu _ PopUpMenu labelList: labels.
			choice _ menu startUp.
			choice = 0
				ifTrue: [akce _ #noAction]
				ifFalse: [choice > categoryList size
						ifTrue: [nodeClass _ Smalltalk at: #StructuredNode]
						ifFalse: [nodeClass _ Smalltalk at: (categoryList at: choice)]]]! !

!ModelarDocument methodsFor: 'superdocument access'!

beTopDocument
	"Dokument na nejvyssi urovni obsahuje hlavni uzel simulace. Tato zprava umisti 
	hlavni uzel do dokumentu, pokud se tam jiz nenachazi."

	| node |
	nodeCategory = 'Graph-Nodes-Diskret' asSymbol
		ifTrue: [node _ MainNode new: 80 @ 50]
		ifFalse: [node _ ContMainNode new: 80 @ 50].
	node number: 0.
	node offset: origin + (50 @ 10).
	self addNode: node.
	hierarchiLevel _ 0.
	lastNodeNumber _ 0!

predLevel
	"vrati se zpet na vyssi hierarchickou uroven"

	self hierarchiLevel > 0
		ifTrue: 
			[self dependents do: [:obj | obj model: superDocument].
			superDocument changed: #title]
		ifFalse: [self akce: #noAction]!

renumberHierarchiLevel: aNumber 
	self hierarchiLevel: aNumber.
	nodes do: [:node | (node isKindOf: StructuredNode)
			ifTrue: [node subStructure == nil ifFalse: [node subStructure renumberHierarchiLevel: aNumber + 1]]]!

superDocument
	"vraci nadrazeny dokument"

	^superDocument!

superDocument: aDocument
	"nastavi nadrazeny dokument na aDocument"

	superDocument _ aDocument!

topDocument
	"vraci dokument na nejvyssi hierarchicke urovni"

	self hierarchiLevel = 0
		ifTrue: [^self]
		ifFalse: [^self superDocument topDocument]! !

!ModelarDocument methodsFor: 'connections'!

connectionNearestTo: aPoint 
	"Vraci spoj nejblizsi k bodu aPoint. Vzdalenost musi byt mensi nez 10 bodu."

	| ind d minD con |
	minD _ nil.
	1 to: connections size do: 
		[:i | 
		d _ (connections at: i)
					distanceFrom: aPoint.
		minD == nil
			ifTrue: 
				[minD _ d.
				ind _ i]
			ifFalse: [d < minD
					ifTrue: 
						[minD _ d.
						ind _ i]]]. 
	minD == nil
		ifTrue: [^nil]
		ifFalse: [minD < 10
				ifTrue: 
					["pokud je vzdalenost kurzoru od hrany vetsi operace se 
					ignoruje"
					con _ connections at: ind.
					^con]
				ifFalse: [^nil]]!

connections: aCollectionOfConnections
	
connections _ aCollectionOfConnections!

connectionsOnNode: aNumber 
	"vraci seznam spoju koncich nebo zacinajicich v danem uzlu"

	| b |
	b _ Bag new.
	connections do: [:con | con begin = aNumber | (con end = aNumber) ifTrue: [b add: con]].
	^b!

findConnectionWithLabelAt: aPoint 
	"vraci spoje jehoz label obsahuje bod aPoint"

	| inx rect|
	inx _ connections findFirst: [:con | rect _ con label asParagraph relativeRectangle .
		rect moveTo: (con firstPoint + con labelPosition).
		rect containsPoint: aPoint].
	inx = 0 ifTrue: [^nil].
	^connections at: inx!

visibleConnections
	"vraci spoje, ktere zacinaji nebo konci uvnitr okna "

	| b clip |
	b _ Bag new.
	clip _ self origin corner: (origin + extent).
	connections do: [:con | (clip containsPoint: (con at: 1))
			| (clip containsPoint: (con at: con size)) ifTrue: [b add: con]].
	^b! !

!ModelarDocument methodsFor: 'accessing'!

activate
	"Nastavi tento dokument jako aktivni"

	ModelarDocument activate: self!

defaultInspectorClass
 	^DocumentInspector!

extent
	"vraci rozmer okna ve kterem je zobrazovan"

	^extent!

extent: aPoint 
	"nastavi velikost okna, ve kterem bude dokument zobrazovan"

	self extent ~= aPoint
		ifTrue: 
			[extent _ aPoint.
			origin _ 0@0.
			self changed: #extent]!

hierarchiLevel
	"vraci cislo hierarchicke urovne prijemnce"

	^hierarchiLevel!

hierarchiLevel: level
	"nastavi  cislo hierarchicke urovne prijemnce na level"

	hierarchiLevel _ level!

komentar
	^komentar!

komentar: aCommentString 
	komentar _ aCommentString!

lastNodeNumber
	"Vraci nejvetsi cislo uzlu pouziteho v tomto dokumentu."

	^lastNodeNumber!

lastNodeNumber: aNumber
	"Nastavuje nejvetsi cislo uzlu pouziteho v tomto dokumentu."

	lastNodeNumber _ aNumber!

nodeCategory
	^nodeCategory!

nodeCategory: aSymbolOfCategory 
	nodeCategory _ aSymbolOfCategory!

number
	"vraci cislo dokumentu"

	^number!

number: aNumber 
	"zapise cislo dokumentu"

	number _ aNumber!

origin
	"vraci relativni pocatek zobrazovaneho dokumentu"

	^origin!

origin: aPoint 
	"presune souradnice pocatku vyrezu do bodu aPoint"

	self origin ~= aPoint
		ifTrue: 
			[origin _ aPoint.
			self changed: #origin]!

renumber
	"provede precislovani vsech uzlu a odkazu na ne"

	| mpa |
	mpa _ Dictionary new.
	self lastNodeNumber: (self topDocument renumber: mpa from: 1) - 1.
	self changed!

renumber: aMapArray from: startingNumber 
	"precisluje uzly a odkazy na ne. Pri precislovani vyuziva pole aMapArray, ktere 
	mapuje puvodni cisla na nova"

	| i n |
	i _ startingNumber.
	nodes do: 
		[:node | 
		n _ node number.
		aMapArray at: 0 put: 0.
		n > 0
			ifTrue: 
				[aMapArray at: n put: i.
				node number: i.
				i _ i + 1].
		n < 0
			ifTrue: 
				[aMapArray at: n put: 0 - i.
				node number: 0 - i.
				node externNumber: (aMapArray at: node externNumber).
				i _ i + 1]].
	connections do: 
		[:con | 
		con begin: (aMapArray at: con begin).
		con end: (aMapArray at: con end)].
	nodes do: [:node | (node class isKindOf: StructuredNode class)
			ifTrue: [node subStructure ~~ nil ifTrue: [i _ node subStructure renumber: aMapArray from: i]]].
	^i!

title
	"vraci titulek dokumentu"

	^title!

title: aString 
	"nastavi titulek dokumentu"

	title _ aString.
	self hierarchiLevel > 0 ifTrue: [(self superDocument nodeWithNumber: self number)
			label: aString].
	self changed: #title! !

!ModelarDocument methodsFor: 'initialize-release'!

initialize
	nodes _ OrderedCollection new.
	connections _ OrderedCollection new.
	nodeClass _ Smalltalk at: #GraphNode.
	origin _ 0@0.
	title _ 'untitled'.
	extent _ 0@0.
	hierarchiLevel _ 0.
	superDocument _ nil.
	akce _ #noAction.
	dirty _ false.
	lastNodeNumber _ -1!

initialize: aSymbol 
	nodes _ OrderedCollection new.
	connections _ OrderedCollection new.
	aSymbol = #diskret
		ifTrue: [nodeCategory _ 'Graph-Nodes-Diskret' asSymbol]
		ifFalse: [nodeCategory _ 'Graph-Nodes-Spoj' asSymbol].
	nodeClass _ Smalltalk at: #GraphNode.
	origin _ 0 @ 0.
	title _ 'untitled'.
	extent _ 0 @ 0.
	hierarchiLevel _ 0.
	superDocument _ nil.
	akce _ #noAction.
	dirty _ false.
	lastNodeNumber _ -1.
	komentar _ ''! !

!ModelarDocument methodsFor: 'removing'!

removeConnectionNearestTo: aPoint 
	"zrusi hranu, ktera lezi nejblize bodu aPoint"

	| ind d minD con node |
	minD _ nil.
	1 to: connections size do: 
		[:i | 
		d _ (connections at: i)
					distanceFrom: aPoint.
		minD == nil
			ifTrue: 
				[minD _ d.
				ind _ i]
			ifFalse: [d < minD
					ifTrue: 
						[minD _ d.
						ind _ i]]]. 
	minD == nil
		ifTrue: [^false]
		ifFalse: [minD < 10
				ifTrue: 
					["pokud je vzdalenost kurzoru od hrany vetsi operace se 
					ignoruje"
					con _ connections at: ind.
					node _ self nodeWithNumber: con begin.
					(node isKindOf: StructuredNode)
						ifTrue: [node subStructure == nil ifFalse: ["musime smazat port na nasledujici hierarchicke urovni"
								node subStructure removeNodeWithNumber: (node subStructure portOnNode: con end)]].
					node _ self nodeWithNumber: con end.
					(node isKindOf: StructuredNode )
						ifTrue: [node subStructure == nil ifFalse: ["musime smazat port na nasledujici hierarchicke urovni"
								node subStructure removeNodeWithNumber: (node subStructure portOnNode: con begin)]].
					connections removeAtIndex: ind.
					^true]
				ifFalse: [^false]]!

removeConnectionsOn: numberOfNode 
	"smaze spojeni vychazejici nebo koncici v uzlu s indexem indexNode"

	| node |
	connections removeAllSuchThat: [:con | con begin = numberOfNode | (con end = numberOfNode)
			ifTrue: 
				[node _ self nodeWithNumber: con begin.
				(node  isKindOf: StructuredNode )
					ifTrue: [node subStructure == nil ifFalse: ["musime smazat port na nasledujici hierarchicke urovni"
							node subStructure removeNodeWithNumber: (node subStructure portOnNode: con end)]].
				node _ self nodeWithNumber: con end.
				(node  isKindOf: StructuredNode)
					ifTrue: [node subStructure == nil ifFalse: ["musime smazat port na nasledujici hierarchicke urovni"
							node subStructure removeNodeWithNumber: (node subStructure portOnNode: con begin)]].
				true]
			ifFalse: [false]]!

removeNodeAt: aPoint 
	"zrusi uzel obsahujici bod aPoint"

	| ind nd |
	ind _ nodes findFirst: [:node | node containsPoint: aPoint].
	ind = 0
		ifFalse: 
			[nd _ nodes at: ind.
			nd number < 1 ifTrue: [^true].
			(nd isKindOf: StructuredNode)
				ifTrue: [nd subStructure ~~ nil
						ifTrue: 
							[BinaryChoice
								message: 'Uzel obsahuje podstrukturu. Opravdu zrusit ?'
								displayAt: Sensor cursorPoint
								centered: true
								ifTrue: 
									[self removeConnectionsOn: (nodes at: ind) number.
									nodes removeAtIndex: ind]
								ifFalse: [].
							^true]].
			self removeConnectionsOn: (nodes at: ind) number.
			nodes removeAtIndex: ind.
			^true].
	^false!

removeNodeWithNumber: aNumber 
	"zrusi uzel s cislem aNumber"

	self removeConnectionsOn: aNumber.
	nodes removeAllSuchThat: [:node | node number = aNumber]! !

!ModelarDocument methodsFor: 'moving'!

moveConnectionsOn: aNumber 
	"presune konce spojeni zacinajici nebo koncici na uzlu s cislem aNumber"

	| clipRect1 clipRect2    |
	connections do: [:con | con begin = aNumber | (con end = aNumber)
			ifTrue: 
				[clipRect1 _ (self nodeWithNumber: con begin) relativeRectangle.
				clipRect2 _ (self nodeWithNumber: con end) relativeRectangle.
				con moveBeginTo: clipRect1 center.
				con moveEndTo: clipRect2 center.
				con makeOrthogonal.
				con clipBeginBy: clipRect1.
				con clipEndBy: clipRect2.
				con countLabelPos]]! !

!ModelarDocument methodsFor: 'adding'!

addConnection: con 
	"zaradi do seznamu spoju dalsi polozku"

	| clipRect1 clipRect2  node scale port relativpos   |
	clipRect1 _ (self nodeWithNumber: con begin) relativeRectangle.
	con moveBeginTo: clipRect1 center.
	clipRect2 _ (self nodeWithNumber: con end) relativeRectangle.
	con moveEndTo: clipRect2 center.
	con makeOrthogonal.
	(con size = 2) & (con begin = con end) ifTrue: [^false].
	con clipBeginBy: clipRect1.
	con clipEndBy: clipRect2.
	connections add: con.
	node _ self nodeWithNumber: con begin.
	(node class isKindOf: StructuredNode class)
		ifTrue: [node subStructure == nil
				ifFalse: 
					[scale _ node subStructure extent / node extent.
					port _ Port new: 30 @ 30.
					port out.
					con end >= 0
						ifTrue: [port externNumber: con end]
						ifFalse: [port externNumber: (self nodeWithNumber: con end) externNumber].
					relativpos _ (con firstPoint - node offset * scale) rounded.
					node subStructure addPort: port onPosition: relativpos]].
	node _ self nodeWithNumber: con end.
	(node class isKindOf: StructuredNode class)
		ifTrue: [node subStructure == nil
				ifFalse: 
					[scale _ node subStructure extent / node extent.
					port _ Port new: 30 @ 30.
					port in.
					con begin >= 0
						ifTrue: [port externNumber: con begin]
						ifFalse: [port externNumber: (self nodeWithNumber: con begin) externNumber].
					relativpos _ (con last - node offset * scale) rounded.
					node subStructure addPort: port onPosition: relativpos]]!

addNode: aNode 
	"prida do dokumentu dalsi uzel"

	nodes add: aNode!

addPort: aPort onPosition: pos
	"umisti do dokumentu novy port na doporucenou pozici pos, pokud je to mozne.
	Je-li pozice pos obsazena pokusi se umistit port na jine misto"

	| rect step |
	rect _ (aPort relativeRectangle) moveTo: pos.
	pos x > (extent // 2)
		ifTrue: [step _ 5 @ 0]
		ifFalse: [step _ -5 @ 0].
	[(self isNodeAt: rect)]
		whileTrue: [rect moveBy: step].
	aPort offset: rect origin.
	self addNode: aPort! !

!ModelarDocument methodsFor: 'fileIn/Out'!

fileIn
	"nacte novy dokument ze souboru"

	| newDoc mpa flag fileList fileName choice |
	newDoc _ self.
	FillInTheBlank
		request: 'Jmeno souboru pro cteni: '
		displayAt: Sensor cursorPoint
		centered: true
		action: [:answer | answer = ''
				ifFalse: 
					[fileList _ Filename defaultClass filesMatching: answer.
					fileList size > 0
						ifTrue: [choice _ (PopUpMenu labelList: (Array with: fileList)) startUp]
						ifFalse: [choice _ 0].
					choice > 0
						ifTrue: 
							[fileName _ fileList at: choice.
							newDoc _ BinaryStorage fromFileNamed: fileName.
							newDoc hierarchiLevel: 0.
							mpa _ Dictionary new.
							newDoc lastNodeNumber: (newDoc renumber: mpa from: self topDocument lastNodeNumber + 1).
							flag _ true]
						ifFalse: [flag _ false]]]
		initialAnswer: '*.gsm'.
	flag
		ifTrue: 
			[self hierarchiLevel > 0
				ifTrue: 
					[BinaryChoice
						message: 'Pouzit jako podstrukturu?'
						displayAt: Sensor cursorPoint
						centered: true
						ifTrue: [flag _ true]
						ifFalse: [flag _ false].
					flag
						ifTrue: 
							[newDoc nodeCategory ~= self nodeCategory ifTrue: [^self confirm: 'Dokument neni stejneho typu'].			self topDocument lastNodeNumber: newDoc lastNodeNumber.
							newDoc removeNodeWithNumber: 0.
							newDoc renumberHierarchiLevel: self hierarchiLevel.
							self nodes do: [:node | node number < 0 ifTrue: [newDoc addPort: node onPosition: node offset]].
							newDoc number: self number.
							newDoc superDocument: self superDocument.
							(self superDocument nodeWithNumber: self number)
								subStructure: newDoc.
							(self superDocument nodeWithNumber: self number)
								label: newDoc title]].
			dependents do: [:obj | obj model: newDoc].
			ModelarDocument activate: newDoc.
			self release.
			newDoc changed: #title]!

fileOut
	"Ulozi dokument do souboru na disk. Ukladat se muze pouze na nejvyssi urovni."

	self hierarchiLevel > 0
		ifTrue: [self confirm: 'Ukladat lze pouze kompletni dokument - hierarchicka uroven 0']
		ifFalse: [FillInTheBlank
				request: 'Jmeno souboru pro zapis: '
				displayAt: Sensor cursorPoint
				centered: true
				action: [:answer | answer = '' ifFalse: [answer asFilename exists
							ifTrue: [BinaryChoice
									message: 'Soubor ' , answer , ' existuje. Prepsat ?'
									displayAt: Sensor cursorPoint
									centered: true
									ifTrue: [BinaryStorage put: self onFileNamed: answer]
									ifFalse: []]
							ifFalse: [BinaryStorage put: self onFileNamed: answer]]]
				initialAnswer: (self title chopTo: 8)
						, '. gsm']!

storeBinaryOn: stream

	stream storeRecordOfClass: self class.
	stream nextPut: hierarchiLevel.
	stream nextPut: number.
	stream nextPut: lastNodeNumber.
	stream nextPut: title.
	stream nextPut: nodes.
	stream nextPut: connections.
	stream nextPut: nodeCategory.
	stream nextPut: komentar! !

!ModelarDocument methodsFor: 'error handling'!

confirm: aMessageString 
	"predefinovana metoda ze tridy Object. Zobrazi okno se zpravou 
	aMessageString a ceka na potvrzeni stiskem tlacitka Ok. Pote vraci false."

	ConfirmDialog message: aMessageString.
	^false! !

!ModelarDocument methodsFor: 'compiling'!

cancelSim
	MySimulation clear!

compile
	"provede akce predchazejici spusteni simulace"

	| topDocument |
	topDocument _ self topDocument.
	topDocument initCompilation.
	topDocument setNeibours ifFalse: [^false].
	topDocument compileNodes
		ifTrue: 
			[Transcript show: 'Kompilace modelu `' , topDocument title , '` bez chyb...'; cr.
			^true]
		ifFalse: [^false]!

compileNodes
	"spusti kompilacni metody ve vsech uzlech v ramci dokumentu"

	nodes do: [:node | node compile ifFalse: [^false]].
	^true!

initCompilation
	"inicializuje uzly pred kompilaci"

	nodes do: [:node | node initCompilation]!

initConnections
	nodes do: [:node | node initConnections]!

initSim
	| pom |
	pom := MySimulation active.
	pom isNil ifFalse: [pom phase == #SIMULATION ifTrue: [(self confirm: 'Prave probiha simulace instance tridy `' , pom class name , '`' , '
 Opravdu chcete inicializovat simulacni system ?')
				ifTrue: [MySimulation initialize]]]
		ifTrue: [MySimulation initialize]!

initSimulation
	"inicializuje uzly pred kompilaci"

	nodes do: [:node | node initSimulation]!

neighbourOf: number1 withNumber: number2 
	"vraci uzel, ktery je sousedem uzlu s cislem number1 a ma cislo number2. Pokud 
	number2 odpovida portu, hleda sousedni uzel na nadrazene urovni, podkud jde o
	strukturovany uzel (obsahuje dokument na nizsi hierarchice urovni) hleda 
	souseda v substrukture."

	| subStruc conns con port node2 |
	(node2 _ self nodeWithNumber: number2) == nil ifTrue: [node2 _ self nodeWithNumber: (self portOnNode: number2)].
	node2 number >= 0
		ifTrue: 
			["nejedna se o port"
			(node2 isKindOf: StructuredNode)
				ifTrue: 
					["jde o strukturovany uzel"
					(subStruc _ node2 subStructure) == nil
						ifTrue: 
							["substruktura nebyl dosud nadefinovana"
							self confirm: 'Uzel s cislem ' , number2 printString , ' nema nadefinovanou podstrukuru'.
							^nil].
					port _ subStruc nodeWithNumber: ( subStruc portOnNode: number1).
					conns _ subStruc connectionsOnNode: port number.
					conns isEmpty ifTrue: [^nil].
					con _ conns detect: [:x| true].
					con end = port number ifTrue: ["nespravny smer v portu"
						^nil].
					node2 _ subStruc neighbourOf: port number withNumber: con end.
					node2 ~~ nil ifTrue: [port addOutput: node2].
					^node2].
			^node2].
	port _ node2.
	port addInput: (self nodeWithNumber: number1).
	^self superDocument neighbourOf: self number withNumber: port externNumber!

run
	"Spusti simulaci modelu."

	| node |
	nodeCategory = 'Graph-Nodes-Spoj' asSymbol
		ifTrue: 
			[self initSimulation.
			self initConnections].
	node _ self nodeWithNumber: 0.
	node run.
	nodeCategory = 'Graph-Nodes-Diskret' asSymbol ifTrue: [SimInspectorView open: (node defaultInspectorClass inspect: node)
			label: self title]!

runOnBackground
	"Spusti simulaci modelu."

	| node activeDoc |
	nodeCategory = 'Graph-Nodes-Spoj' asSymbol
		ifTrue: 
			[self initSimulation.
			self initConnections].
	node _ self nodeWithNumber: 0.
	activeDoc _ ModelarDocument active.
	ModelarDocument activate: self.
	node runOnBackGround.
	ModelarDocument activate: activeDoc.
	nodeCategory = 'Graph-Nodes-Diskret' asSymbol ifTrue: [SimInspectorView open: (node defaultInspectorClass inspect: node) label: self title]!

setNeibours
	"do vsech uzlu vlozi informace o jejich sousedech."

	| node1 node2 number1 number2 |
	connections do: 
		[:con | 
		number1 _ con begin.
		number2 _ con end.
		node1 _ self nodeWithNumber: number1.
		number1 >= 0 & (node1 isKindOf: StructuredNode ) not
			ifTrue: 
				[node2 _ self neighbourOf: number1 withNumber: number2.
				node2 == nil ifTrue: [^self confirm: 'Chyba v propojeni na uzel s cislem ' , number1 printString].
				node1 addOutput: node2.
				node2 addInput: node1]].
	nodes do: [:node | (node isKindOf: StructuredNode )
			ifTrue: 
				[node subStructure == nil ifTrue: [^self confirm: 'Uzel s cislem ' , node number printString , ' nema definovanou podstrukturu'].
				node subStructure setNeibours ifFalse: [^false]]].
	^true! !

!ModelarDocument methodsFor: 'nodes'!

findNodeAt: aPoint 
	"vraci cislo uzlu uvnitr ktereho lezi bod aPoint"

	| inx |
	inx _ nodes findFirst: [:node | node containsPoint: aPoint].
	inx = 0 ifTrue: [^nil].
	^(nodes at: inx) number!

nodeAtIndex: index
	"vraci uzel s indexem index"

	^nodes at: index!

nodeClass
	"vraci tridu od ktere se budou tvorit instace predstavujici uzly v grafu"

	^nodeClass!

nodes
	^nodes!

nodes: aCollectionOfNodes
	
nodes _ aCollectionOfNodes!

nodeWithNumber: aNumber
	"vraci uzel s cislem aNumber"
	
	|inx|
	inx _ (nodes findFirst: [:node | node number = aNumber]).
	^(self nodeAtIndex: inx)!

portOnNode: aNumber
	"vraci cislo portu, pres ktery vede spoj na uzel s cislem aNumber"

	| inx |
	inx _ nodes findFirst: [:node | node number < 0
					ifTrue: [node externNumber = aNumber]
					ifFalse: [false]].
	^(nodes at: inx) number!

visibleNodes 
	"vraci uzly, ktere jsou viditelne v okne. "

	| b clip vnode |
	clip _ origin corner: (origin + extent).
	b _ Bag new.
	nodes do: [:node | (node intersects: clip)
			ifTrue: 
				[vnode _ node.
				b add: vnode]].
	^b! !

!ModelarDocument methodsFor: 'copying'!

copy
	"Vraci svoji kopii."

	| newDoc newNodes |
	newDoc _ super copy.
	newNodes _ OrderedCollection new.
	nodes do: [:x | newNodes add: x deepCopy].
	newDoc nodes: newNodes.
	^newDoc! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ModelarDocument class
	instanceVariableNames: ''!


!ModelarDocument class methodsFor: 'instance creation'!

diskretSim
   ^super new initialize: #diskret!

new
	^super new initialize!

readBinaryFrom: stream tag: tag 
	"Vraci object precteny ze streamu"

	| doc |
	doc _ self new.
	stream register: doc id: tag.
	doc hierarchiLevel: stream next.
	doc hierarchiLevel ~= 0 ifTrue: [doc superDocument: ModelarDocument active].
	ModelarDocument activate: doc.
	doc number: stream next.
	doc lastNodeNumber: stream next.
	doc title: stream next.
	doc nodes: stream next.
	doc connections: stream next.
	doc nodeCategory: stream next.
	doc komentar: stream next.
	doc akce: #noAction.
	doc origin: 0@0.
	doc extent: 100@100.
	^doc!

spojSim
   ^super new initialize: #spoj! !

!ModelarDocument class methodsFor: 'active document access'!

activate: aDocument 
	"Nastavi dokument aDocument jako aktivni."

	ActiveDocument _ aDocument!

active
	"Vraci aktivni dokument - prave editovany nebo v nemz prave probita simulace"

	^ActiveDocument! !

ModelarDocument subclass: #ModelarDocumentDiskret
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!ModelarDocumentDiskret methodsFor: 'compiling'!

run
	"Spusti simulaci modelu."

	| node |
	node _ self nodeWithNumber: 0.
	node run.
	SimInspectorView open: (node defaultInspectorClass inspect: node)
			label: self title!

runOnBackground
	"Spusti simulaci modelu."

	| node activeDoc |
	node _ self nodeWithNumber: 0.
	activeDoc _ ModelarDocument active.
	ModelarDocument activate: self.
	node runOnBackGround.
	ModelarDocument activate: activeDoc.
	SimInspectorView open: (node defaultInspectorClass inspect: node)
		label: self title! !

!ModelarDocumentDiskret methodsFor: 'superdocument access'!

beTopDocument
	"Dokument na nejvyssi urovni obsahuje hlavni uzel simulace. Tato zprava umisti 
	hlavni uzel do dokumentu, pokud se tam jiz nenachazi."

	| node |
	node _ MainNode new: 80 @ 50.
	node number: 0.
	node offset: origin + (50 @ 10).
	self addNode: node.
	hierarchiLevel _ 0.
	lastNodeNumber _ 0! !

!ModelarDocumentDiskret methodsFor: 'initialize-release'!

initialize
	super initialize.
	nodeCategory _ 'Graph-Nodes-Diskret' asSymbol! !

ModelarDocument subclass: #ModelarDocumentCont
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!ModelarDocumentCont methodsFor: 'compiling'!

run
	"Spusti simulaci modelu."

	| node |
	self initSimulation.
	self initConnections.
	node _ self nodeWithNumber: 0.
	node run.
	Processor terminateActive!

runOnBackground
	"Spusti simulaci modelu."

	| node activeDoc |
	self initSimulation.
	self initConnections.
	node _ self nodeWithNumber: 0.
	activeDoc _ ModelarDocument active.
	ModelarDocument activate: self.
	node runOnBackGround.
	ModelarDocument activate: activeDoc! !

!ModelarDocumentCont methodsFor: 'initialize-release'!

initialize
	super initialize.
	nodeCategory _ 'Graph-Nodes-Cont' asSymbol! !

!ModelarDocumentCont methodsFor: 'superdocument access'!

beTopDocument
	"Dokument na nejvyssi urovni obsahuje hlavni uzel simulace. Tato zprava umisti 
	hlavni uzel do dokumentu, pokud se tam jiz nenachazi."

	| node |
	node _ ContMainNode new: 80 @ 50.
	node number: 0.
	node offset: origin + (50 @ 10).
	self addNode: node.
	hierarchiLevel _ 0.
	lastNodeNumber _ 0! !

FormMenuView subclass: #MainMenuView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MainMenuView class
	instanceVariableNames: ''!


!MainMenuView class methodsFor: 'instance creation'!

open
	| labels buttonKeys button menuView textView actions para relpos connector aSwitchView topView form |
	labels _ #('Diskretni simulace - graficky' 'Spojita simulace - graficky' 'Simulace - textovy popis' ).
	buttonKeys _ #($d $s $t ).
	menuView _ self new.
	actions _ Array new: 3.
	actions at: 1 put: [ModelarView diskret].
	actions at: 2 put: [ModelarView cont].
	actions at: 3 put: [SimBrowserView open].
	relpos _ 0 @ 0.
	connector _ Object new.
	1 to: 3 do: 
		[:i | 
		para _ (labels at: i) asText allBold asParagraph textStyle: (TextStyle styleNamed: #large).
		para compositionRectangle: (0 @ 0 corner: 300 @ 30).
		para centered.
		form _ Form extent: 300 @ 30.
		para displayOn: form.
		button _ OneOnSwitchRep newOff.
		button onAction: (actions at: i).
		button connection: connector.
		aSwitchView _ SwitchView new model: button.
		aSwitchView key: (buttonKeys at: i).
		aSwitchView label: form.
		aSwitchView insideColor: Form white.
		aSwitchView borderWidth: 1.
		aSwitchView controller selector: #turnOn.
		menuView
			addSubView: aSwitchView
			in: (relpos extent: 1 @ (1 / 3))
			borderWidth: 1.
		relpos _ relpos + (0 @ (1 / 3))].
	topView _ (StandardSystemView new) label: 'Hlavni nabidka simulacniho systemu'; minimumSize: 300 @ 160; maximumSize: 300 @ 160.
	topView
		addSubView: menuView
		in: (0 @ 0 extent: 1 @ 0.7)
		borderWidth: 1.
	textView _ TextCollectorView new.
	textView model: (Smalltalk at: #Transcript).
	textView insideColor: Form white.
	topView
		addSubView: textView
		in: (0 @ 0.7 extent: 1 @ 0.3)
		borderWidth: 1.
	topView controller open! !

Form subclass: #Ikona
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Ikona class
	instanceVariableNames: ''!


!Ikona class methodsFor: 'instance-creation'!

arrow
	"vraci ikonu ve tvaru vodorovne sipky"

	^self
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3 0 0 3 32768 0 1 49152 0 0 57344 0 0 28672 0 0 14336 0 0 7168 0 0 3584 32767 65535 65280 32767 65535 65280 32767 65535 65280 0 0 3584 0 0 7168 0 0 14336 0 0 28672 0 0 57344 0 1 49152 0 3 32768 0 3 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

arrowWithPoint
	"vraci sipku s teckou na zacatku"

	^self
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3 0 0 3 32768 0 1 49152 0 0 57344 0 0 28672 0 0 14336 14336 0 7168 31744 0 3584 65535 65535 65280 65535 65535 65280 65535 65535 65280 31744 0 3584 14336 0 7168 0 0 14336 0 0 28672 0 0 57344 0 1 49152 0 3 32768 0 3 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

book
	^Form
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4095 65504 0 4096 96 0 12288 160 0 12288 288 0 16383 65312 0 13653 21792 0 15018 47904 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43808 0 13653 21792 0 15018 43840 0 13653 21888 0 8191 65280 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

compact
	"vraci ikonu pro prechod na vyssi (predchazejici ) 
	hierarchickou uroven."

	^Form
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 0 0 0 7 65504 0 8196 32 0 28676 32 0 63492 32 0 8196 32 0 8196 32 0 8196 32 0 8199 65504 0 8192 16896 0 8192 16896 0 8192 33024 0 8192 33024 0 8193 128 0 8193 128 0 8194 64 0 8194 64 0 8196 32 0 8703 57855 57344 8533 24917 24576 8618 41386 40960 8533 24917 24576 8618 41386 40960 8533 24917 24576 8703 57855 57344 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

cross
	"vraci kriz v uhlopricce. Slouzi k zruseni objektu"

	^self
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 4096 0 0 6144 0 2048 3072 0 6144 1536 0 12288 768 0 24576 384 0 49152 192 1 32768 96 3 0 48 6 0 24 12 0 12 24 0 6 48 0 3 96 0 1 32960 0 0 49536 0 0 25344 0 0 13824 0 0 7168 0 0 7168 0 0 13824 0 0 25344 0 0 49536 0 1 32960 0 3 96 0 6 48 0 12 24 0 24 12 0 48 6 0 96 3 0 192 1 32768 384 0 49152 768 0 24576 1536 0 12288 3072 0 6144 6144 0 2048 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

crossedArrow
	"vraci preskrtnutou sipku"

	^self
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 24576 0 49152 12288 1 32768 6144 3 0 3072 6 0 1536 12 0 768 24 0 384 48 0 192 99 0 96 195 32768 48 385 49152 24 768 57344 12 1536 28672 6 3072 14336 3 6144 7168 1 45056 3584 32767 65535 65280 32767 65535 65280 32767 65535 65280 1 45056 3584 3 6144 7168 6 3072 14336 12 1536 28672 24 768 57344 48 385 49152 96 195 32768 192 99 0 384 48 0 768 24 0 1536 12 0 3072 6 0 6144 3 0 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

crossedRectangle
	"vraci preskrtnuty obdelnik"

	^self
		extent: 40 @ 40
		fromArray: #(0 0 0 8192 0 2048 12288 0 6144 6144 0 12288 3072 0 24576 32767 65535 64512 32767 65535 64512 24960 1 35840 24768 3 3072 24672 6 3072 24624 12 3072 24600 24 3072 24588 48 3072 24582 96 3072 24579 192 3072 24577 33152 3072 24576 49920 3072 24576 26112 3072 24576 15360 3072 24576 7168 3072 24576 13824 3072 24576 25344 3072 24576 49536 3072 24577 32960 3072 24579 96 3072 24582 48 3072 24588 24 3072 24600 12 3072 24624 6 3072 24672 3 3072 32767 65535 64512 32767 65535 64512 768 0 49152 1536 0 24576 3072 0 12288 6144 0 6144 4096 0 2048 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

expand
	"vraci ikonu pro expandovani strukturovaneho uzlu - prechod na dalsi 
	hierarchickou uroven."

	^Form
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 0 0 0 7 65504 0 6 43680 0 8197 21856 0 8198 43680 0 8197 21856 0 8198 43680 0 8197 21856 0 8199 65504 0 8192 16896 0 8192 16896 0 8192 33024 0 8192 33024 0 8193 128 0 8193 128 0 8194 64 0 8194 64 0 8196 32 0 8703 57855 57344 8448 8448 8192 8448 8448 8192 8448 8448 8192 8448 8448 8192 8448 8448 8192 8703 57855 57344 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 63488 0 0 28672 0 0 8192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

fileIn
	"vraci ikonu pro nacteni modelu ze souboru"

	^Form
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 2047 65535 0 1024 1 0 1024 1 0 1024 7 0 1024 7 0 1024 1 0 1024 1 0 1024 28673 0 1024 63489 0 1025 64513 0 1025 64513 0 1025 64513 0 1024 63617 0 1024 28673 0 1024 1 0 1024 1 0 1024 24577 0 1024 36865 0 1024 36865 0 1024 36865 0 1024 36865 0 1024 36865 0 1024 24577 0 1024 1 0 2047 65535 0 0 0 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 63488 0 0 28672 0 0 8192 0 0 0 0 )
		offset: 0 @ 0!

fileOut
	"vraci ikonu pro ulozeni vytvareneho modelu do souboru"

	^Form
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 2047 65535 0 1024 1 0 1024 1 0 1024 7 0 1024 7 0 1024 1 0 1024 1 0 1024 28673 0 1024 63489 0 1025 64513 0 1025 64513 0 1025 64513 0 1024 63617 0 1024 28673 0 1024 1 0 1024 1 0 1024 24577 0 1024 36865 0 1024 36865 0 1024 36865 0 1024 36865 0 1024 36865 0 1024 24577 0 1024 1 0 2047 65535 0 0 0 0 0 8192 0 0 28672 0 0 63488 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 0 0 )
		offset: 0 @ 0!

fourDirections
	"vraci ikonu krize pro posun objektu"

	^self
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 0 8192 0 0 28672 0 0 43008 0 1 9216 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 2048 8192 16384 4096 8192 8192 8192 8192 4096 32767 65535 63488 8192 8192 4096 4096 8192 8192 2048 8192 16384 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 1 9216 0 0 43008 0 0 28672 0 0 8192 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

fourDirectionsRectangle

^self
	extent: 40@40
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 8192 0 0 28672 0 0 43008 0 1 9216 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 255 65532 0 128 8196 0 128 8196 0 128 4 0 128 4 8192 2176 4 4096 4224 4 2048 8320 31 64512 32760 4 2048 8320 4 4096 4224 4 8192 2176 4 0 128 8196 0 128 8196 0 255 65532 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 0 8192 0 1 9216 0 0 43008 0 0 28672 0 0 8192 0 0 0 0 0 0 0)
	offset: 0@0!

hand
	^Form
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 24576 0 6 39936 0 9 37376 0 9 37504 0 4 37696 0 4 37440 0 26 576 0 38 64 0 34 128 0 16 128 0 8 128 0 4 256 0 4 256 0 2 512 0 1 512 0 1 512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

rectangle
	"vraci ikonu obdelnika"

	^self
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 32767 65535 64512 32767 65535 64512 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 24576 0 3072 32767 65535 64512 32767 65535 64512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
		offset: 0 @ 0!

run
	"vraci ikonu pro spusteni simulace"

	^Form
		extent: 40 @ 40
		fromArray: #(0 0 0 0 0 0 0 0 0 7 0 0 31 49152 0 31 49152 0 63 57344 0 63 57344 0 63 57344 0 31 49152 0 31 49152 0 7 0 0 7 0 0 127 64512 0 234 44544 0 501 24448 0 1002 45024 0 2037 24568 0 4010 44030 0 7989 22782 0 15914 43070 0 15381 22542 0 14362 43008 0 12309 22528 0 26 43008 0 31 63488 0 31 63488 0 31 63488 0 31 64512 0 31 32256 0 30 16128 0 30 8064 0 30 4032 0 30 2016 0 30 1008 0 30 504 0 30 252 0 31 0 0 31 32768 0 0 0 0 )
		offset: 0 @ 0! !

IconController subclass: #IconControllerCZ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

IconControllerCZ class
	instanceVariableNames: ''!


!IconControllerCZ class methodsFor: 'class initialization'!

initialize
	"IconController initialize"

	IconYellowButtonMenu _ PopUpMenu labels: 'puvodni velikost'.
	IconYellowButtonMessages _ #(expand ).
	self allInstances do: [:controller | controller initialize]! !

IconControllerCZ initialize!


OneOnSwitch subclass: #OneOnSwitchRep
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!OneOnSwitchRep methodsFor: 'state'!

turnOn
	"prepne prepinac do stavu zapnuto. Akce pri zapnuti se provede vzdy."

	self isOff
		ifTrue: 
			[on _ true.
			self changed.
			self notifyConnection].
	self doAction: onAction! !

View subclass: #ModelarView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!ModelarView methodsFor: 'displaying'!

displayView
	| visibles box |
	self model activate.
	box _ self insetDisplayBox.
	model extent: box extent.
	visibles _ model visibleNodes.
	visibles do: [:node | node
			displayOn: Display
			at: (box origin- self model origin)
			clippingBox: box
			].
	visibles _ model visibleConnections.
	visibles do: [:con | con
			displayOn: Display
 			at: (box origin - self model origin)
			clippingBox: box
			rule: Form over
			mask: Form black]! !

!ModelarView methodsFor: 'updating'!

update: aParameter 
	"prekresli svou plochu. Pokud se zmenil titulek modelu, zajisti zmenu v 
	rodicovskem view"

	aParameter = #title
		ifTrue: 
			[self topView newLabel: 'Editor modelu - [' , self model title , ']'.
			self topView controller == ScheduledControllers activeController ifFalse: [^self]].
	self display! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ModelarView class
	instanceVariableNames: ''!


!ModelarView class methodsFor: 'instance creation'!

cont
	"Otevre nove okno pro graficky editor simulacniho modelu a priradi mu novy 
	dokument."

	| document |
	document _ ModelarDocumentCont new.
	document beTopDocument.
	^self openOn: document!

diskret
	"Otevre nove okno pro graficky editor simulacniho modelu a priradi mu novy 
	dokument."

	| document |
	document _ ModelarDocumentDiskret  new.
	document beTopDocument.
	^self openOn: document!

open
	"Otevre nove okno pro graficky editor simulacniho modelu a priradi mu novy 
	dokument."

	| document |
	document _ ModelarDocument diskretSim.
	document beTopDocument.
	^self openOn: document!

openOn: document 
	| modelarView moverView ikonMenu topView |
	modelarView _ (ModelarView new) model: document; controller: ModelarController new; insideColor: Form white.
	moverView _ (MoverView new) model: document; controller: MoverController new; insideColor: Form white.
	ikonMenu _ IkonMenuView iconMenu model: document.
	topView _ (StandardSystemView new) label: 'Editor modelu - [' , document title , ']'; minimumSize: 500 @ 400.
	topView controller: StandardSystemControllerCZ new.
	topView
		addSubView: modelarView
		in: (0 @ 0 extent: 0.7 @ 1)
		borderWidth: 1.
	topView
		addSubView: moverView
		in: (0.7 @ 0.7 extent: 0.3 @ 0.3)
		borderWidth: 1.
	topView 
		addSubView: ikonMenu
		in: (0.7@0 extent: 0.3 @0.7)
		borderWidth: 1.
	topView cacheRefresh: false.
	ModelarDocument activate: document.
	topView controller open! !

MouseMenuController subclass: #MoverController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!MoverController methodsFor: 'control defaults'!

isControlActive
	^super isControlActive & sensor blueButtonPressed not! !

!MoverController methodsFor: 'menu messages'!

move
	"interaktivni nastaveni pocatku souradnic v dokumentu, ktery je modelem"

	| mvbox dispbox pos oldpos curofset realpos pos1|
	dispbox _ self view insetDisplayBox.
	mvbox _ self view moverBox.
	mvbox offset: (mvbox offset + (dispbox origin)).
	pos _ Sensor cursorPoint.
	(mvbox relativeRectangle containsPoint: pos)
		ifTrue: 
			[Cursor currentCursor: Cursor hand.
			Display fill: dispbox mask: Form white.
			oldpos _ pos.
			curofset _ pos - mvbox offset.	"posunuti kurzoru oproti pocatku posouvaneho obdelnika"
			realpos _ pos1 _ mvbox offset.
			mvbox offset: 0@0.
			mvbox
				displayOn: Display
				at: realpos
				clippingBox: dispbox
				rule: Form reverse
				mask: Form black.
			[Sensor redButtonPressed]
				whileTrue: 
					[pos _ Sensor cursorPoint.
					pos ~= oldpos
						ifTrue: 
							[realpos _ pos - curofset.
							realpos x < dispbox left ifTrue: [realpos x: dispbox left].
							realpos y < dispbox top ifTrue: [realpos y: dispbox top].
							realpos x + mvbox extent x > dispbox right ifTrue: [realpos x: dispbox right - mvbox extent x].
							realpos y + mvbox extent y > dispbox bottom ifTrue: [realpos y: dispbox bottom - mvbox extent y].
							pos _ realpos + curofset.
							Sensor cursorPoint: pos.
							mvbox
								displayOn: Display
								at: oldpos - curofset
								clippingBox: dispbox
								rule: Form reverse
								mask: Form black.
							mvbox
								displayOn: Display
								at: realpos
								clippingBox: dispbox
								rule: Form reverse
								mask: Form black.
							oldpos _ pos]].
			Cursor currentCursor: Cursor normal.
			self model origin: (self model origin translateBy: (realpos - pos1 * 10) rounded)]
		ifFalse: [Sensor waitNoButton]!

redButtonActivity
	"Determine which item in the select button menu is selected.
	If one is selected, then send the corresponding message to the object
	designated as the menu message receiver."

	self menuMessageReceiver perform: #move! !

MouseMenuController subclass: #DialogBoxController
	instanceVariableNames: 'status '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!


!DialogBoxController methodsFor: 'menu messages'!

close
	status _ #terminate! !

!DialogBoxController methodsFor: 'initialize-release'!

initialize
	super initialize.
	blueButtonMenu _ PopUpMenu
		labels: 'close'.
	blueButtonMessages _ #(close).
	status _ #active! !

!DialogBoxController methodsFor: 'control defaults'!

isControlActive
	
	(status ~= #active) ifTrue: [^false].
	[super isControlActive] whileFalse: [view flash].
	^true! !

!DialogBoxController methodsFor: 'basic control sequence'!

startUp

	Cursor normal showWhile: [super startUp]! !

StandardSystemController subclass: #StandardSystemControllerCZ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Modelar-interface'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

StandardSystemControllerCZ class
	instanceVariableNames: ''!


!StandardSystemControllerCZ class methodsFor: 'class initialization'!

initialize
	"Initialize the class variables."

	"StandardSystemController initialize.
	StandardSystemController allInstances do: [:sc | sc initializeBlueButtonMenu]"

	ScheduledBlueButtonMenu _ PopUpMenu labels: 'Nove oznaceni\Okno pod\Posuv\Roztahnuti\Ikona\Zavrit' withCRs lines: #(1 5 ).
	ScheduledBlueButtonMessages _ #(newLabel under move frame collapse close ).
	MenuWhenCollapsed _ ActionMenu
				labels: 'Nove oznaceni\Okno pod\Posuv\Puvodni velikost\Zavrit' withCRs
				lines: #(1 4 )
				selectors: #(newLabel under move expand close ).
	RedIsBlueInTab _ false.	"Default: do not pop up blue button menu in title tab."! !

StandardSystemControllerCZ initialize!
