BasicMatFunOne subclass: #Abs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Abs comment:
' Trida ''Abs'' je matematicky blok ''Absolutni hodnota''.
Promenne instanci dedi po svem otci.'!


!Abs methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble abs].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom abs! !

BasicMatFunOne subclass: #Inv
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Inv comment:
' Trida ''Inv'' je matematicky blok ''Negace''.
Promenne instanci dedi po svem otci.'!


!Inv methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble negated].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom negated! !

BasicMatFunOne subclass: #Sqr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Sqr comment:
' Trida ''Sqr'' je matematicky blok ''Mocnina''.
Promenne instanci dedi po svem otci.'!


!Sqr methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble * oneInput asDouble].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom * pom! !

BasicMatFunOne subclass: #Exp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Exp comment:
' Trida ''Exp'' je matematicky blok ''Funkce e na x-tou''.
Promenne instanci dedi po svem otci.'!


!Exp methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble exp].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom exp! !

BasicMatFunTwo subclass: #Mul
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Mul comment:
' Trida ''Mul'' je matematicky blok ''Nasobeni''.
Promenne instanci dedi po svem otci.'!


!Mul methodsFor: 'task language'!

as: oInput mul: tInput 
	"Nastavuje odkazy na vstupni hodnoty."

	twoInput := tInput.
	oneInput := oInput!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom pom1 |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal)
		ifTrue: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: [^oneInput asDouble * twoInput asDouble]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					eval := false.
					^oneInput asDouble * pom]]
		ifFalse: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := oneInput value asDouble.
					eval := false.
					^pom * twoInput asDouble]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					pom1 := oneInput value asDouble.
					eval := false.
					^pom1 * pom]]! !

BasicMatFunOne subclass: #Tan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Tan comment:
' Trida ''Tan'' je matematicky blok ''Tangenc''.
Promenne instanci dedi po svem otci.'!


!Tan methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble tan].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom tan! !

BasicMatFunOne subclass: #Sqrt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Sqrt comment:
' Trida ''Sqrt'' je matematicky blok ''Druha odmocnina''.
Promenne instanci dedi po svem otci.'!


!Sqrt methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble sqrt].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom sqrt! !

BasicMatFunOne subclass: #Cos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Cos comment:
' Trida ''Cos'' je matematicky blok ''Cosinus''.
Promenne instanci dedi po svem otci.'!


!Cos methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble cos].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom cos! !

BasicMatFunOne subclass: #Sum
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!


!Sum methodsFor: 'task language'!

as: oInput sum: tInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput := Array new: 2.
	oneInput at: 1 put: oInput.
	oneInput at: 2 put: tInput!

as: oInput sum: tInput sum: thInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput := Array new: 3.
	oneInput at: 1 put: oInput.
	oneInput at: 2 put: tInput.
	oneInput at: 3 put: thInput!

as: oInput sum: tInput sum: thInput sum: fInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput := Array new: 4.
	oneInput at: 1 put: oInput.
	oneInput at: 2 put: tInput.
	oneInput at: 3 put: thInput.
	oneInput at: 4 put: fInput!

as: oInput sum: tInput sum: thInput sum: fInput sum: fiInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput := Array new: 5.
	oneInput at: 1 put: oInput.
	oneInput at: 2 put: tInput.
	oneInput at: 3 put: thInput.
	oneInput at: 4 put: fInput.
	oneInput at: 5 put: fiInput!

as: oInput sum: tInput sum: thInput sum: fInput sum: fiInput sum: sInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput := Array new: 6.
	oneInput at: 1 put: oInput.
	oneInput at: 2 put: tInput.
	oneInput at: 3 put: thInput.
	oneInput at: 4 put: fInput.
	oneInput at: 5 put: fiInput.
	oneInput at: 6 put: sInput!

as: oInput sum: tInput sum: thInput sum: fInput sum: fiInput sum: sInput sum: seInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput := Array new: 7.
	oneInput at: 1 put: oInput.
	oneInput at: 2 put: tInput.
	oneInput at: 3 put: thInput.
	oneInput at: 4 put: fInput.
	oneInput at: 5 put: fiInput.
	oneInput at: 6 put: sInput.
	oneInput at: 7 put: seInput!

as: oInput sum: tInput sum: thInput sum: fInput sum: fiInput sum: sInput sum: seInput sum: eInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput := Array new: 8.
	oneInput at: 1 put: oInput.
	oneInput at: 2 put: tInput.
	oneInput at: 3 put: thInput.
	oneInput at: 4 put: fInput.
	oneInput at: 5 put: fiInput.
	oneInput at: 6 put: sInput.
	oneInput at: 7 put: seInput.
	oneInput at: 8 put: eInput!

as: oInput sum: tInput sum: thInput sum: fInput sum: fiInput sum: sInput sum: seInput sum: eInput sum: nInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput := Array new: 9.
	oneInput at: 1 put: oInput.
	oneInput at: 2 put: tInput.
	oneInput at: 3 put: thInput.
	oneInput at: 4 put: fInput.
	oneInput at: 5 put: fiInput.
	oneInput at: 6 put: sInput.
	oneInput at: 7 put: seInput.
	oneInput at: 8 put: eInput.
	oneInput at: 9 put: nInput!

as: oInput sum: tInput sum: thInput sum: fInput sum: fiInput sum: sInput sum: seInput sum: eInput sum: nInput sum: teInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput := Array new: 10.
	oneInput at: 1 put: oInput.
	oneInput at: 2 put: tInput.
	oneInput at: 3 put: thInput.
	oneInput at: 4 put: fInput.
	oneInput at: 5 put: fiInput.
	oneInput at: 6 put: sInput.
	oneInput at: 7 put: seInput.
	oneInput at: 8 put: eInput.
	oneInput at: 9 put: nInput.
	oneInput at: 10 put: teInput!

sum: aInput 
	"Nastavuje odkazy na vstupni hodnoty."

	oneInput = '' ifTrue: [oneInput _ Array new: 0].
	oneInput := oneInput copyWith: aInput!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom x |
	pom := 0 asDouble.
	x := oneInput size + 1.
	[(x := x - 1) > 0]
		whileTrue: [((oneInput at: x)
				isKindOf: Fraction)
				| ((oneInput at: x)
						isKindOf: Integer) | ((oneInput at: x)
					isKindOf: LimitedPrecisionReal)
				ifTrue: [pom := pom + (oneInput at: x) asDouble]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := pom + (oneInput at: x) value asDouble.
					eval := false]].
	^pom! !

BasicMatFunOne subclass: #Ln
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Ln comment:
' Trida ''Ln'' je matematicky blok ''Prirozeny logaritmus''.
Promenne instanci dedi po svem otci.'!


!Ln methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble ln].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom ln! !

BasicMatFunOne subclass: #ArcSin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
ArcSin comment:
' Trida ''ArcSin'' je matematicky blok ''Arcus sinus''.
Promenne instanci dedi po svem otci.'!


!ArcSin methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble arcSin].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom arcSin! !

BasicMatFunTwo subclass: #Mod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Mod comment:
' Trida ''Mod'' je matematicky blok ''Zbytek po deleni''.
Promenne instanci dedi po svem otci.  Pri deleni nulou nabidne uzivateli ukonceni simulace. Pokud tak neudela vraci hodnotu citatele.'!


!Mod methodsFor: 'task language'!

as: oInput mod: tInput 
	"Nastavuje odkazy na vstupni hodnoty."

	twoInput := tInput.
	oneInput := oInput!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom pom1 |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal)
		ifTrue: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: [twoInput = 0
						ifTrue: 
							[MySimulation error: 'Deleni nulou.'.
							^oneInput]
						ifFalse: [^(oneInput asDouble quo: twoInput asDouble) abs]]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					eval := false.
					pom = 0
						ifTrue: 
							[MySimulation error: 'Deleni nulou.'.
							^oneInput]
						ifFalse: [^(oneInput asDouble quo: pom) abs]]]
		ifFalse: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := oneInput value asDouble.
					eval := false.
					twoInput = 0
						ifTrue: 
							[MySimulation error: 'Deleni nulou.'.
							^pom]
						ifFalse: [^(pom quo: twoInput) abs]]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					pom1 := oneInput value asDouble.
					eval := false.
					pom = 0
						ifTrue: 
							[MySimulation error: 'Deleni nulou.'.
							^pom1]
						ifFalse: [^(pom1 quo: pom) abs]]]! !

BasicMatFunTwo subclass: #Max
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Max comment:
' Trida ''Max'' je matematicky blok ''Maximalni hodnota''.
Promenne instanci dedi po svem otci.'!


!Max methodsFor: 'task language'!

as: oInput max: tInput 
	"Nastavuje odkazy na vstupni hodnoty."

	twoInput := tInput.
	oneInput := oInput!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom pom1 |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal)
		ifTrue: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: [^oneInput asDouble max: twoInput asDouble]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					eval := false.
					self halt.
					^oneInput max: pom]]
		ifFalse: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := oneInput value asDouble.
					eval := false.
					^pom max: twoInput asDouble]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					pom1 := oneInput value asDouble.
					eval := false.
					^pom1 max: pom]]! !

BasicMatFunOne subclass: #Sin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Sin comment:
' Trida ''Sin'' je matematicky blok ''Sinus''.
Promenne instanci dedi po svem otci.'!


!Sin methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble sin].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom sin! !

BasicMatFunTwo subclass: #Div
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Div comment:
' Trida ''Div'' je matematicky blok ''Deleni''.
Promenne instanci dedi po svem otci. Pri deleni nulou nabidne uzivateli ukonceni simulace. Pokud tak neudela vraci hodnotu citatele.'!


!Div methodsFor: 'task language'!

as: oInput div: tInput 
	"Nastavuje odkazy na vstupni hodnoty."

	twoInput := tInput.
	oneInput := oInput!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom pom1 |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal)
		ifTrue: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: [twoInput = 0
						ifTrue: 
							[MySimulation error: 'Deleni nulou.'.
							^oneInput]
						ifFalse: [^oneInput asDouble / twoInput asDouble]]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					eval := false.
					pom = 0
						ifTrue: 
							[MySimulation error: 'Deleni nulou.'.
							^oneInput]
						ifFalse: [^oneInput asDouble / pom]]]
		ifFalse: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := oneInput value asDouble.
					eval := false.
					twoInput = 0
						ifTrue: 
							[MySimulation error: 'Deleni nulou.'.
							^pom]
						ifFalse: [^pom / twoInput asDouble]]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					pom1 := oneInput value asDouble.
					eval := false.
					pom = 0
						ifTrue: 
							[MySimulation error: 'Deleni nulou.'.
							^pom1]
						ifFalse: [^pom1 / pom]]]! !

BasicMatFunOne subclass: #ArcTan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
ArcTan comment:
' Trida ''arcTan'' je matematicky blok ''Arcus tangenc''.
Promenne instanci dedi po svem otci.'!


!ArcTan methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble arcTan].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom arcTan! !

BasicMatFunTwo subclass: #Min
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Min comment:
' Trida ''Min'' je matematicky blok ''Minimalni hodnota''.
Promenne instanci dedi po svem otci.'!


!Min methodsFor: 'task language'!

as: oInput min: tInput 
	"Nastavuje odkazy na vstupni hodnoty."

	twoInput := tInput.
	oneInput := oInput!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom pom1 |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal)
		ifTrue: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: [^oneInput asDouble min: twoInput asDouble]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					eval := false.
					^oneInput asDouble min: pom]]
		ifFalse: [(twoInput isKindOf: Fraction)
				| (twoInput isKindOf: Integer) | (twoInput isKindOf: LimitedPrecisionReal)
				ifTrue: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := oneInput value asDouble.
					eval := false.
					^pom min: twoInput asDouble]
				ifFalse: 
					[eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
					eval := true.
					pom := twoInput value asDouble.
					pom1 := oneInput value asDouble.
					eval := false.
					^pom1 min: pom]]! !

BasicMatFunOne subclass: #ArcCos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
ArcCos comment:
' Trida ''ArcCon'' je matematicky blok ''Arcus cosinus''.
Promenne instanci dedi po svem otci.'!


!ArcCos methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [^oneInput asDouble arcCos].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	^pom arcCos! !

BasicMatFunOne subclass: #Div1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContSimMatFun'!
Div1 comment:
' Trida ''Div1'' je matematicky blok ''1/x''.
Promenne instanci dedi po svem otci.  Pri deleni nulou nabidne uzivateli ukonceni simulace. Pokud tak neudela vraci hodnotu citatele.'!


!Div1 methodsFor: 'task language'!

value
	"Vraci vypocitanou hodnotu vystupu."

	| pom |
	(oneInput isKindOf: Fraction)
		| (oneInput isKindOf: Integer) | (oneInput isKindOf: LimitedPrecisionReal) ifTrue: [oneInput = 0
			ifTrue: 
				[MySimulation error: 'Deleni nulou.'.
				^1]
			ifFalse: [^1 / oneInput asDouble]].
	eval ifTrue: [MySimulation error: 'V simulacnim modelu je algebraicka smycka.'].
	eval := true.
	pom := oneInput value asDouble.
	eval := false.
	pom = 0
		ifTrue: 
			[MySimulation error: 'Deleni nulou.'.
			^1]
		ifFalse: [^1 / pom]! !